
#include<stdio.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/socket.h>
#include<netinet/in_systm.h>
#include<netinet/in.h>
#include<netinet/ip.h>
#include<arpa/inet.h>
#include<stdlib.h>
#include<string.h>
#include<pthread.h>
#include<time.h>
#include<errno.h>

#include"zither.h"
#include<almemsys/almemsys.h>
#include"jpreturn.h"

#ifdef POSTGRES_IN
  #include<libpq-fe.h>
  extern PGconn * conn;
  extern PGresult * res;
#endif

extern global_data_t gd;


int pqconnect(void)
{
int ret;
ret = 0;

conn = PQconnectdb(gd.pg.postgres_data);
switch(PQstatus(conn)){
   case CONNECTION_STARTED:
        fprintf(stderr, "pqconnect(1): 接続確立待ち postgres.\n");
        break;
   case CONNECTION_MADE:
        fprintf(stderr, "pqconnect(2): 接続OK送信待ち postgres.\n");
        break;
   case CONNECTION_AWAITING_RESPONSE:
        fprintf(stderr, "pqconnect(3): サーバからの接続待ち postgres.\n");
        break;
   case CONNECTION_BAD:
        fprintf(stderr, "pqconnect(4): 接続出来ない postgres.\n");
        fprintf(stderr, "pqconnect(5): %s", PQerrorMessage(conn));
        PQfinish(conn);
        ret = -1;
        break;
   default:
        #ifdef POSTGRES_DEBUG
        fprintf(stderr, "POSTGRES_DEBUG: pqconnect(6): 正常に接続できました postgres.\n");
        #endif
        ret = 1;
   }

return ret;
}






